' //////////////////////////////////////////////////////////////////////
' WAS: RJH_SpaceWar_Virtual_VGA_032.SPIN - Free flight space battle
'
' NOW: Vector art test
'///////////////////////////////////////////////////////////////////////
' CONSTANTS SECTION ////////////////////////////////////////////////////
'///////////////////////////////////////////////////////////////////////

CON

'--- USER CONFIGURATION -----------------------------------------------------------------------------------------------
' Uncomment one of the sections below to select your resolution. Also select your desired COLOUR_MODE
'
' Supported resolutions are:
'
'  640x480 2 colour & 4 colour
'  800x600 2 colour & 4 colour
' 1024x768 2 colour only
' 1152x864 2 colour only
'

  COLOUR_MODE       = 1                ' 0 = 2 colour mode, 1 = 4 colour mode. Not all resolutions support 4 colours.

  DOUBLE_BUFFER     = TRUE             ' Double buffering is recommended for screens that are redrawn rapidly.
                                       ' (Note that you cannot turn double buffering on or off "on the fly").
                                       ' It is recommended to leave this on.

  RAM_RECYCLE       = TRUE             ' Reclaim the RAM used for cog data once the cogs are loaded. If you set
                                       ' this to FALSE you will probably not be able to have sound effects or
                                       ' keyboard support at the higher resolutions (*)                                       

  SFX_COG           = TRUE             ' SFX Manager runs on own cog (better quality sound). Set this to false if
                                       ' you want sound effects AND the keyboard - otherwise you run out of cogs.

' (* Note: to simplify disabling sound effects or keyboard support, dummy drivers are provided. See the OBJ section)


'--- 640 x 480 --------------------------------------------------------------------------------------------------------

  'vga constants:
  mode = COLOUR_MODE << 3 + %000
  '    72Hz       60Hz
  hd = 640        '640
  hf = 24         '16
  hs = 40         '96
  hb = 128        '48
  vd = 480        '480
  vf = 9          '10
  vs = 3          '4
  vb = 28         '33
  px = 31_500_000 '25_000_000


  _clkmode = xtal1 + pll8x            ' enable external clock and pll times 8
  _xinfreq = 10_000_000 + 0000        ' set frequency to 10 MHZ plus some error for xtals that are not exact add 1000-5000 usually works
  _stack = $32                       ' accomodate stack

  'DEBUG OPTIONS:
  DEBUG__SHOW_WATCH_VARIABLES   = FALSE
  DEBUG__SHOW_PACING_OVERRUNS   = FALSE
  DEBUG__ENABLE_DEBUG_MODE      = FALSE
  DEBUG__ENABLE_TEST_MONKEY     = FALSE
  DEBUG__SHOW_PACING_LED        = FALSE

  
  ' graphics driver and screen constants
  PARAMCOUNT        = 21        

  ' screen constants:
  X_TILES           = hd / (32>>COLOUR_MODE) 
  Y_TILES           = vd / 16 

  SCREEN_WIDTH      = X_TILES * (32>>COLOUR_MODE)   
  SCREEN_HEIGHT     = Y_TILES * 16 

            
  'Vector drawing commands
  VECTOR_MOVE           = $4000
  VECTOR_DRAW           = $8000
  VECTOR_END            = $0000


'///////////////////////////////////////////////////////////////////////
' VARIABLES SECTION ////////////////////////////////////////////////////
'///////////////////////////////////////////////////////////////////////

VAR

  long  vga_status    '0/1/2 = off/visible/invisible           read-only
  long  vga_enable    '0/? = off/on                            write-only
  long  vga_pins      '%ppmmm = pins                           write-only
  long  vga_mode      '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  vga_screen    'pointer to screen (words)               write-only
  long  vga_colors    'pointer to colors (longs)               write-only               
  long  vga_hc        'horizontal cells                        write-only
  long  vga_vc        'vertical cells                          write-only
  long  vga_hx        'horizontal cell expansion               write-only
  long  vga_vx        'vertical cell expansion                 write-only
  long  vga_ho        'horizontal offset                       write-only
  long  vga_vo        'vertical offset                         write-only
  long  vga_hd        'horizontal display pixels               write-only
  long  vga_hf        'horizontal front-porch pixels           write-only
  long  vga_hs        'horizontal sync pixels                  write-only
  long  vga_hb        'horizontal back-porch pixels            write-only
  long  vga_vd        'vertical display lines                  write-only
  long  vga_vf        'vertical front-porch lines              write-only
  long  vga_vs        'vertical sync lines                     write-only
  long  vga_vb        'vertical back-porch lines               write-only
  long  vga_rate      'pixel rate (Hz)                         write-only

  long  line_req
  long  line_buf


' RJH - implement 4 bits of colour -------------------------------------------------------------- OLD
'
  long  line_1[x_tiles]       ' (1 long per x tile - pixels only)
  long  line_2[x_tiles]       ' (1 long per x tile - pixels only)
  long  line_3[x_tiles]       ' (1 long per x tile - pixels only)
  long  line_4[x_tiles]       ' (1 long per x tile - pixels only)

' RJH - implement 4 bits of colour -------------------------------------------------------------- NEW
'
' NOTE : THIS DOESN'T WORK YET - NEED 2 VGA DRIVERS AS WELL AS 2 LINE GENERATORS !!!
'
'  long  line_1[x_tiles<<COLOUR_MODE]       ' (1 long per x tile - pixels only, or colours then pixels)
'  long  line_2[x_tiles<<COLOUR_MODE]       ' (1 long per x tile - pixels only, or colours then pixels)
'  long  line_3[x_tiles<<COLOUR_MODE]       ' (1 long per x tile - pixels only, or colours then pixels)
'  long  line_4[x_tiles<<COLOUR_MODE]       ' (1 long per x tile - pixels only, or colours then pixels)

' RJH - implement 4 bits of colour -------------------------------------------------------------- END

  long  initial_ram
  long  initial_tiles

  long  fast_screen[7]

  word  onscreen[x_tiles * y_tiles]  ' storage for screen tile map 
  word  offscreen[x_tiles * y_tiles] ' storage for screen tile map
  word  map[x_tiles * y_tiles]       ' storage for screen tile map

  long  colors[16]                   ' color look up table (16 combinations max for VGA - only 1 currently used)


  
  long vbase_offset, vcolor, x0, y0, x1, y1,x2,y2         ' used to cache each vector

'///////////////////////////////////////////////////////////////////////
' OBJECT DECLARATION SECTION ///////////////////////////////////////////
'///////////////////////////////////////////////////////////////////////
OBJ

  vga    : "RJH_Virtual_VGA_drv_012.spin"               ' Virtual VGA driver
  gr     : "SHADOW_Virtual_Graphics_drv_011.spin"          ' Virtual Graphics driver
'  gr     : "RJH_Virtual_Graphics_drv_011.spin"          ' Virtual Graphics driver
'///////////////////////////////////////////////////////////////////////
' EXPORT PUBLICS  //////////////////////////////////////////////////////
'///////////////////////////////////////////////////////////////////////

PUB start | i , j, dx, dy, pp, pq, rr, numx, numchr,index

  '//// GLOBAL INITIALIZTION
  
  'init debug LED
  DIRA[0] := 1 ' output 
  OUTA[0] := 0
                 
  'setup vga
  longmove(@vga_status, @vgaparams, paramcount)
  vga_colors := @colors

  line_req := 0
  line_buf := 0

  fast_screen[0] := @line_req
  fast_screen[1] := @line_buf
  if DOUBLE_BUFFER
    fast_screen[2] := @onscreen
  else
    fast_screen[2] := @offscreen
  fast_screen[3] := @line_1
  fast_screen[4] := @line_2
  fast_screen[5] := @line_3
  fast_screen[6] := @line_4
  vga_screen := @fast_screen
             
  'init colors - colour 1 is white so it can be used in both 2 colour and 4 colour mode
  repeat i from 0 to 16
    colors[i] := %11000000_00001100_11111100_00000000

  initial_ram := (word[$e] + _stack*4 + $00FF) & $FF00
  initial_tiles := ($8000 - initial_ram) / 64 

  'start and setup graphics
  gr.start

  gr.setup(COLOUR_MODE, X_TILES, Y_TILES, X_TILES*16>>COLOUR_MODE, Y_TILES*8, @offscreen, @map, initial_tiles, initial_ram)

  gr.setup(COLOUR_MODE, X_TILES, Y_TILES, 0, 0, @offscreen, @map, initial_tiles, initial_ram)

  gr.db_setup(@onscreen, DOUBLE_BUFFER)

  vga.start(@vga_status)

  if RAM_RECYCLE
    'now that graphics cogs are loaded, reclaim the RAM that was used to hold their data
    gr.addram (gr.ramstart, gr.ramend)
    gr.addram (gr.db_ramstart, gr.db_ramend)
    gr.addram (vga.ramstart, vga.ramend)
    gr.addram (vga.lg_ramstart, vga.lg_ramend)
{
  '//// MAIN EXECUTION MANAGER
  repeat
    'gr.clear
    
    'Draw the "///M" logo
    repeat index from 0 to static_m_patches[0]
      vbase_offset := 1 + index*7 ' pre-compute 
      vcolor := static_m_patches[vbase_offset + 0] ' color at offset 0
      
      x0    := static_m_patches[vbase_offset + 1] ' first point at offset 1,2
      y0    := {SCREEN_HEIGHT - }static_m_patches[vbase_offset + 2] - 1
       
      x1    := static_m_patches[vbase_offset + 3] ' second point at offset 3,4      
      y1    := {SCREEN_HEIGHT - }static_m_patches[vbase_offset + 4] -1

      x2    := static_m_patches[vbase_offset + 5] ' second point at offset 3,4      
      y2    := {SCREEN_HEIGHT - }static_m_patches[vbase_offset + 6] -1

      gr.color(vcolor)
      gr.tri(x0,y0, x1,y1, x2,y2)

}

  repeat
    gr.clear
    {
    repeat index from 0 to static_m_patches[0]
      vbase_offset := 1 + index*7 ' pre-compute
      vcolor := static_m_patches[vbase_offset + 0] ' color at offset 0

      x0    := static_m_patches[vbase_offset + 1] ' first point at offset 1,2
      y0    := SCREEN_HEIGHT - static_m_patches[vbase_offset + 2] - 1

      x1    := static_m_patches[vbase_offset + 3] ' second point at offset 3,4
      y1    := SCREEN_HEIGHT - static_m_patches[vbase_offset + 4] -1

      x2    := static_m_patches[vbase_offset + 5] ' second point at offset 3,4
      y2    := SCREEN_HEIGHT - static_m_patches[vbase_offset + 6] -1

      'gr.color(vcolor)
      gr.tri(x0,y0, x1,y1, x2,y2)
    }
    gr.color(1)
    'gr.tri(0,0,100,0,0,100)
    gr.tri(300,300,  400,300,  300,400)

    gr.finish

    gr.copy(@onscreen)
    waitcnt(cnt + clkfreq)

'///////////////////////////////////////////////////////////////////////
' DATA SECTION /////////////////////////////////////////////////////////
'///////////////////////////////////////////////////////////////////////


DAT

' TV PARAMETERS FOR DRIVER /////////////////////////////////////////////

vgaparams               long    0               'status
                        long    1               'enable
                        long    %010_111        'pins
                        long    mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    1               'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    hd
                        long    hf
                        long    hs
                        long    hb
                        long    vd
                        long    vf
                        long    vs
                        long    vb
                        long    px


' POLYGON OBJECTS ///////////////////////////////////////////////////////
                   
static_m_patches        WORD 16  ' 16 for ///M

                        ' 1st bar (2x)
                        WORD 1,   104, 16,   120, 16,   96,  64
                        WORD 1,   96,  64,   80,  64,   104, 16
                         
                        ' 2nt bar (2x)
                        WORD 2,   120, 16,   136, 16,   112, 64
                        WORD 2,   112, 64,   96,  64,   120, 16
                         
                        ' 3rd bar (2x)
                        WORD 3,   136, 16,   152, 16,   128, 64
                        WORD 3,   128, 64,   112, 64,   136,16
                         
                        'm  (10x)
                        WORD 1,    128, 64 , 148, 64 , 152, 16
                        WORD 1,    148, 64 , 168, 16 , 152, 16
                        WORD 1,    156, 44 , 168, 64 , 168, 16
                        WORD 1,    156, 64 , 156, 44 , 168, 64
                        WORD 1,    168, 64 , 168, 40 , 180, 16
                        WORD 1,    168, 64 , 172, 64 , 180, 16
                        WORD 1,    172, 64 , 180, 16 , 191, 16
                        WORD 1,    180, 44 , 191, 16 , 180, 64
                        WORD 1,    196, 16 , 191, 16 , 180, 64
                        WORD 1,    196, 64 , 196, 16 , 180, 64

red_lights              WORD 46   ' 18 for three arrows 28 for sevenseg

                        'Ahead arrow  (5x)
                        WORD 240,80  , 194, 132,  286, 132
                        WORD 194,132 , 194,134,   286,134
                        WORD 194,132,  286,132,  286,134
                        WORD 216,134,  216,142,  263, 142
                        WORD 216,134,  263,134,  263,142

                        'Beside arrow (8x)
                        WORD 192,155,  209,171,  209,139
                        WORD 212,171,  209,171,  209,139
                        WORD 212,171,  212,139,  209,139
                        WORD 212,162,  212,148,  268,162
                        WORD 268,148,  212,148,  268,162
                        WORD 268,171,  268,139,  270,139
                        WORD 268,171,  270,171,  270,139
                        WORD 270,171,  288,155,  270,139

                        'Bottom arrow (5x)
                        WORD 217,174,  217,169,  263,169
                        WORD 217,174,  263,174,  263,169
                        WORD 194,174,  286,174,  286,176
                        WORD 240,192,  194,176,  286,176
                        WORD 194,174,  194,176,  286,176

                        'A
                        WORD 118,237,115,242,118,231
                        WORD 158,242,115,242,118,231
                        WORD 158,242,154,231,118,231
                        WORD 158,242,154,231,158,236
                        'B
                        WORD 167,142,173,137,178,142
                        WORD 167,142,172,180,178,142
                        WORD 167,142,172,180,162,179
                        WORD 166,185,172,180,162,179
                        'C
                        WORD 174,92,180,87,185,92
                        WORD 174,92,179,130,185,92
                        WORD 174,92,179,130,169,129
                        WORD 173,135,179,130,169,129
                        'D
                        WORD 132,86,136,91,139,80
                        WORD 172,91,136,91,139,80
                        WORD 172,91,175,80,139,80
                        WORD 172,91,175,80,179,85
                        'E
                        WORD 125,92,131,87,136,92
                        WORD 125,92,130,130,136,92
                        WORD 125,92,130,130,120,129
                        WORD 124,135,130,130,120,129
                        'F
                        WORD 118,142,124,137,129,142
                        WORD 118,142,123,180,129,142
                        WORD 118,142,123,180,113,179
                        WORD 117,185,123,180,113,179
                        'G
                        WORD 125,136,129,141,132,130
                        WORD 165,141,129,141,132,130
                        WORD 165,141,168,130,132,130
                        WORD 165,141,168,130,172,135


fixed_pt_string_0        byte    "-00000.0000",0    'text
int_string_0             byte    "-00000",0         'text
game_over_string         byte    "GAME OVER",0      'text
game_over_restart        byte    "PRESS <START>",0  'text
'debug_string             byte    "DEBUG",0          'text

title1_string            byte    "SPACEWAR!",0                  'text
version_string           byte    "3.2 (HIRES VGA)",0            'text
title3_string            byte    "WRITTEN BY ERIC MOYER",0      'text
title4_string            byte    "VGA MODS BY ROSS HIGSON",0    'text
title_start_string       byte    "PRESS <START> TO BEGIN",0     'text 

options_string           byte    "OPTIONS - UP/DOWN SELECTS, 'A' CHANGES",0        'text

option_strings           byte    "BLACK HOLE",0     'text
                         byte    "SHOT GRAVITY",0   'text
                         byte    "INERTIAL SHOTS",0 'text
                         byte    "SHIELDS",0        'text
                         byte    "FUEL",0           'text
                         byte    "TWINKLE",0        'text
                         byte    "HYPERSPACE",0     'text
                         byte    "SHIP DAMAGE",0    'text
                         byte    "RANDOM ROCKS",0   'text
                         byte    "BOUNCE BACK",0    'text
                         byte    "NEGATIVE GRAVITY",0 'text
                         byte    "EXPANDED UNIVERSE",0 'text
                         byte    $ff                'end of option string list  
'                         byte    "BFG",0            'text
                         
                         
on_string                byte    "ON",0              'text
off_string               byte    "OFF",0             'text
         
